freeze;

//////////////////////////////////////////////////
// IsSumOfSquares
// (just for completeness)
intrinsic IsSumOfSquares( a::FldComElt ) -> BoolElt
{
Returns true iff a is a sum of squares
}
    return true;
end intrinsic;

intrinsic IsSOS( a::FldComElt ) -> BoolElt
{ " }
    return IsSumOfSquares(a);
end intrinsic;


//////////////////////////////////////////////////
// LengthOfSOS
// (just for completeness)
intrinsic LengthOfSOS( a::FldComElt ) -> RngIntElt
{
Given a nonzero element a, this function determines
minimal number of summands needed to express a as a sum of squares. 
It returns 0 if a is not a sum of squares
}
    return 1;
end intrinsic;

intrinsic LengthOfSumOfSquares( a::FldComElt ) -> RngIntElt
{ " } //"
    return LengthOfSOS(a);
end intrinsic;


//////////////////////////////////////////////////
// SolveSOS
// (just for completeness)
intrinsic SolveSOS( a::FldComElt ) -> FldComElt
{
Let a be a sum of squares in K. Assume that the length of a is n.
This function solves the equation a = x1^2 + ... + xn^2 in K.
For the complex numbers this is just an envelope for Sqrt.
}
    test, sqrt_a := IsSquare(a);
    return sqrt_a;
end intrinsic;

intrinsic SolveSumOfSquares( a::FldComElt ) -> FldComElt
{ " } //"
    return SolveSOS(a);
end intrinsic;


