freeze;

declare attributes FldCom: Witt_ring;


function is_isotropic_CC( q )
    // Given a quadratic form q with complex coefficients,
    // this function tests if q is isotropic.

    return Dimension(q) gt 1;
end function;

function is_hyperbolic_CC( q )
    // Given a quadratic form q with real coefficients,
    // this function tests if q is isotropic.

    return IsEven(Dimension(q));
end function;

function anisotropic_dimension_CC( q )
// Given a quadratic form q over the complex numbers, 
// this function returns a dimension of an anisotropic part of q.
    return IsEven(Dimension(q)) select 0 else 1;
end function;


//////////////////////////////////////////////////
// IsTorsion
// just for completeness
function is_torsion_CC( _q )
// Check if the element _q of a Witt ring is torsion.
    return true;
end function;

