freeze;

// Just for consistency with other fields
intrinsic RandomElement( K::FldCom : size := 1 ) -> FldComElt
{
Returns a random element a of K. 
}
    p := Precision(K);
    re := Random(-size*10^p, size*10^p)*10.0^-p;
    im := Random(-size*10^p, size*10^p)*10.0^-p;
    return K![re, im];
end intrinsic;

intrinsic RandomDiagonalQuadraticForm( K::FldCom, d::RngIntElt : size := 1 ) -> DiagQuadFrm
{ 
Construct a random quadratic form of dimension d. 
}
    require d gt 0 : "Dimension must be positive!";
    q := DiagonalQuadraticForm(K, [0]);
    while IsDegenerate( q ) do  
        q := DiagonalQuadraticForm(K, [ RandomElement(K : size := size) : j in [1..d] ]);
    end while;
    return q;
end intrinsic;

intrinsic RandomDQF( K::FldCom, d::RngIntElt : size := 1 ) -> DiagQuadFrm
{ " } //"
    return RandomDiagonalQuadraticForm(K, d : size := size);
end intrinsic;

