freeze;

// Just for consistency with other fields
intrinsic RandomElement( K::FldFin : size := 0 ) -> FldFinElt
{
Returns a random element a of K. 
}
    return Random(K);
end intrinsic;

intrinsic RandomDiagonalQuadraticForm( K::FldFin, d::RngIntElt : size := 0 ) -> DiagQuadFrm
{ 
Construct a random quadratic form of dimension d. 
}
    require d gt 0 : "Dimension must be positive!";
    q := DiagonalQuadraticForm(K, [0]);
    while IsDegenerate( q ) do  
        q := DiagonalQuadraticForm(K, [ RandomElement(K : size := size) : j in [1..d] ]);
    end while;
    return q;
end intrinsic;

intrinsic RandomDQF( K::FldFin, d::RngIntElt : size := 0 ) -> DiagQuadFrm
{ " } //"
    return RandomDiagonalQuadraticForm(K, d : size := size);
end intrinsic;

