 freeze;

//////////////////////////////////////////////////
// IsLocalSquare

intrinsic IsLocalSquare( a::FldNumElt, P::PlcNumElt ) -> BoolElt
{ 
Given an element a in K, decide if a is a square in the completion K_P
}
    return IsLocalSquare(a, Ideal(P));
end intrinsic;




//////////////////////////////////////////////////
// LegendreSymbol

intrinsic LegendreSymbol( a::FldNumElt, P::PlcNumElt ) -> RngIntElt
{ 
Given an element a and a place P of a number field, 
this function computes the Legendre symbol a over P. 
}
    v := Valuation(a, P);
    if IsOdd(v) then
        return 0;
    end if;
    if v ne 0 then
        p := UniformizingElement(P);
        a := a*p^(-v);
    end if;
    if IsSquare(Evaluate(a,P)) then
        return 1;
    end if;
    return -1;
end intrinsic;

intrinsic LegendreSymbol( a::FldNumElt, P::RngOrdIdl ) -> RngIntElt
{ " }
    require IsPrime(P): "P must be a prime ideal!";
    return LegendreSymbol(a, Place(P));
end intrinsic;


