freeze;

intrinsic RandomElement( K::FldFunRat : size := 8 ) -> FldNumElt
{
Returns a random element a of K.
}
    require IsGlobal(K) : "Unsupported field!";
    F := ConstantField(K);
    a := K! [ Random(F) : i in [1..size] ];
    return a;
end intrinsic;

intrinsic RandomDiagonalQuadraticForm( K::FldFunRat, d::RngIntElt : size := 8 ) -> DiagQuadFrm
{ 
Construct a random quadratic form of dimension d. 
}
    require d gt 0 : "Dimension must be positive!";
    q := DiagonalQuadraticForm(K, [0]);
    while IsDegenerate( q ) do  
        q := DiagonalQuadraticForm(K, [ RandomElement(K : size := size) : j in [1..d] ]);
    end while;
    return q;
end intrinsic;

intrinsic RandomDQF( K::FldFunRat, d::RngIntElt : size := 8 ) -> DiagQuadFrm
{ " } //"
    return RandomDiagonalQuadraticForm(K, d : size := size);
end intrinsic;

