freeze;

// Just for consistency with other fields
intrinsic RandomElement( K::FldRat : size := 0 ) -> FldReElt
{
Returns a random element a of K. 
}
    if IsZero( size ) then
        size := 2^16;
    end if;
    p := Random(-size, size);
    q := 0;
    while IsZero(q) do
        q := Random(-size, size);
    end while;
    return K!(p/q);
end intrinsic;

intrinsic RandomDiagonalQuadraticForm( K::FldRat, d::RngIntElt : size := 0 ) -> DiagQuadFrm
{ 
Construct a random quadratic form of dimension d. 
}
    require d gt 0 : "Dimension must be positive!";
    q := DiagonalQuadraticForm(K, [0]);
    while IsDegenerate( q ) do  
        q := DiagonalQuadraticForm(K, [ RandomElement(K : size := size) : j in [1..d] ]);
    end while;
    return q;
end intrinsic;

intrinsic RandomDQF( K::FldRat, d::RngIntElt : size := 0 ) -> DiagQuadFrm
{ " } //"
    return RandomDiagonalQuadraticForm(K, d : size := size);
end intrinsic;

