freeze;


//////////////////////////////////////////////////
// IsSumOfSquares
// (just for completeness)
intrinsic IsSumOfSquares( a::FldReElt ) -> BoolElt
{
Returns true iff a is a sum of squares
}
    return a ge 0;
end intrinsic;

intrinsic IsSOS( a::FldReElt ) -> BoolElt
{ " } //"
    return IsSumOfSquares(a);
end intrinsic;


//////////////////////////////////////////////////
// LengthOfSOS
// (just for completeness)
intrinsic LengthOfSOS( a::FldReElt ) -> RngIntElt
{
Given a nonzero element a, this function determines
minimal number of summands needed to express a as a sum of squares. 
It returns 0 if a is not a sum of squares
}
    return IsSOS(a) select 1 else 0;
end intrinsic;

intrinsic LengthOfSumOfSquares( a::FldReElt ) -> RngIntElt
{ " } //"
    return LengthOfSOS(a);
end intrinsic;


//////////////////////////////////////////////////
// SolveSOS
// (just for completeness)
intrinsic SolveSOS( a::FldReElt ) -> FldReElt
{
Let a be a sum of squares in K. Assume that the length of a is n.
This function solves the equation a = x1^2 + ... + xn^2 in K.
For the reals this is just an envelope for Sqrt.
}
    test, sqrt_a := IsSquare(a);
    require test : "The argument must be positive!";
    return sqrt_a;
end intrinsic;

intrinsic SolveSumOfSquares( a::FldReElt ) -> FldReElt
{ " } //"
    return SolveSOS(a);
end intrinsic;


