freeze;

function isotropic_vector_RR( q : alg := "v2" )
    assert IsIsotropic(q);
    K := BaseField(q);
    C := Coefficients(q);
    
    P := [ i : i in [1..#C] | C[i] gt 0 ];
    N := [ i : i in [1..#C] | C[i] lt 0 ];
    
    v := [K| 0 : c in C];
    v[P[1]] := Sqrt( Abs(C[N[1]]) );
    v[N[1]] := Sqrt( C[P[1]] );
    
    return Vector(K, v);    
end function;

