freeze;

// Just for consistency with other fields
intrinsic RandomElement( K::FldRe : size := 1 ) -> FldReElt
{
Returns a random element a of K. 
}
    p := Precision(K);
    return Random(-size*10^p, size*10^p)*(K!10)^-p;
end intrinsic;

intrinsic RandomDiagonalQuadraticForm( K::FldRe, d::RngIntElt : size := 1 ) -> DiagQuadFrm
{ 
Construct a random quadratic form of dimension d. 
}
    require d gt 0 : "Dimension must be positive!";
    q := DiagonalQuadraticForm(K, [0]);
    while IsDegenerate( q ) do  
        q := DiagonalQuadraticForm(K, [ RandomElement(K : size := size) : j in [1..d] ]);
    end while;
    return q;
end intrinsic;

intrinsic RandomDQF( K::FldRe, d::RngIntElt : size := 1 ) -> DiagQuadFrm
{ " } //"
    return RandomDiagonalQuadraticForm(K, d : size := size);
end intrinsic;

